from typing import Tuple

from selenium import webdriver
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC


class WebDriverWaiter:
    @staticmethod
    def wait_for(driver: webdriver.Chrome, locator: Tuple[str, str]):
        delay = 10 # seconds
        try:
            WebDriverWait(driver, delay).until(EC.presence_of_element_located(locator))
        except TimeoutException:
            print("Timeout")
