
class SingleOffer():
    def __init__(self):
        self._area : float = None
        self._rooms_number : int = None
        self._floor : int = None
        self._property_form : str = None
        self._state : str = None
        self._location : str = None
        self._construction_year : int = None
        self._price : float = None

    def __str__(self) -> str:
        result = f"Area: {self.area} "
        result += f"rooms number: {self.rooms_number} "
        result += f"floor: {self.floor} "
        result += f"property form: {self.property_form} "
        result += f"state: {self.state} "
        result += f"location: {self.location} "
        result += f"construction year: {self.construction_year} "
        result += f"price: {self.price} "
        return result
    
    @staticmethod
    def get_columns_names() -> list:
        return ["Area", "Rooms", "Floor", "Property form", "State", "Location", "Construction year", "Price"]
    
    def get_dict_repr(self) -> dict:
        return {
            "Area": self.area,
            "Rooms": self.rooms_number,
            "Floor": self.floor,
            "Property form": self.property_form,
            "State": self.state,
            "Location": self.location,
            "Construction year": self.construction_year,
            "Price": self.price
        }

    # Area
    @property
    def area(self):
        return self._area

    @area.setter
    def area(self, area : str):
        area_str = area.replace("m²", "").replace(",", ".")
        self._area = float(area_str)

    # Rooms number
    @property
    def rooms_number(self):
        return self._rooms_number

    @rooms_number.setter
    def rooms_number(self, rooms_number : str):
        self._rooms_number = int(rooms_number)

    # Floor
    @property
    def floor(self):
        return self._floor

    @floor.setter
    def floor(self, floor : str):
        floor_str = floor
        index_of_slash = floor.find("/")
        if index_of_slash != -1:
            floor_str = floor_str[:index_of_slash]
        if floor_str == "parter":
            floor_str = "0"
        self._floor = int(floor_str)

    # Property form
    @property
    def property_form(self):
        return self._property_form

    @property_form.setter
    def property_form(self, property_form : str):
        self._property_form = property_form

    # State
    @property
    def state(self):
        return self._state

    @state.setter
    def state(self, state : str):
        self._state = state

    # Location
    @property
    def location(self):
        return self._location

    @location.setter
    def location(self, location : str):
        self._location = location

    # Construction year
    @property
    def construction_year(self):
        return self._construction_year

    @construction_year.setter
    def construction_year(self, construction_year : str):
        self._construction_year = int(construction_year)

    # Price
    @property
    def price(self):
        return self._price

    @price.setter
    def price(self, price : str):
        price_str = price.replace(" zł", "").replace(",", ".").replace(" ", "")
        self._price = float(price_str)
